<?php

namespace Litecms\Maintenance\Policies;

use Litecms\Maintenance\Models\Contract;
use Illuminate\Foundation\Auth\User as Authenticatable;

trait ContractAction
{

    /**
     * Determine if the given user can copy the given contract.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function copy(Authenticatable $user, Contract $contract)
    {

        if ($authUser->canDo('maintenance.contract.action.copy')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can empty the given contract.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    function empty(Authenticatable $user, Contract $contract) {

        if ($authUser->canDo('maintenance.contract.action.empty')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can transfer the given contract.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function transfer(Authenticatable $user, Contract $contract)
    {

        if ($authUser->canDo('maintenance.contract.action.transfer')) {
            return true;
        }

        $this->model->is_owner;
    }

}
