<?php

namespace Litecms\Maintenance\Policies;

use Litecms\Maintenance\Models\Proposal;
use Illuminate\Foundation\Auth\User as Authenticatable;

trait ProposalAction
{

    /**
     * Determine if the given user can copy the given proposal.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function copy(Authenticatable $user, Proposal $proposal)
    {

        if ($authUser->canDo('maintenance.proposal.action.copy')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can empty the given proposal.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    function empty(Authenticatable $user, Proposal $proposal) {

        if ($authUser->canDo('maintenance.proposal.action.empty')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can transfer the given proposal.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function transfer(Authenticatable $user, Proposal $proposal)
    {

        if ($authUser->canDo('maintenance.proposal.action.transfer')) {
            return true;
        }

        $this->model->is_owner;
    }

}
