<?php

namespace Litecms\Maintenance\Policies;

use Litecms\Maintenance\Models\Vendor;
use Illuminate\Foundation\Auth\User as Authenticatable;

trait VendorAction
{

    /**
     * Determine if the given user can copy the given vendor.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function copy(Authenticatable $user, Vendor $vendor)
    {

        if ($authUser->canDo('maintenance.vendor.action.copy')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can empty the given vendor.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    function empty(Authenticatable $user, Vendor $vendor) {

        if ($authUser->canDo('maintenance.vendor.action.empty')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can transfer the given vendor.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function transfer(Authenticatable $user, Vendor $vendor)
    {

        if ($authUser->canDo('maintenance.vendor.action.transfer')) {
            return true;
        }

        $this->model->is_owner;
    }

}
