<?php

namespace Litecms\Maintenance\Policies;

use Litecms\Maintenance\Models\Workorder;
use Illuminate\Foundation\Auth\User as Authenticatable;

trait WorkorderAction
{

    /**
     * Determine if the given user can copy the given workorder.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function copy(Authenticatable $user, Workorder $workorder)
    {

        if ($authUser->canDo('maintenance.workorder.action.copy')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can empty the given workorder.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    function empty(Authenticatable $user, Workorder $workorder) {

        if ($authUser->canDo('maintenance.workorder.action.empty')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can transfer the given workorder.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function transfer(Authenticatable $user, Workorder $workorder)
    {

        if ($authUser->canDo('maintenance.workorder.action.transfer')) {
            return true;
        }

        $this->model->is_owner;
    }

}
